/*
 EditMesh Operations MacroScript File
 Version:  3ds max 6
 
 Revision History:
 	11 dec 2003, Pierre-Felix Breton, 
		added product switcher: this macroscript file can be shared with all Discreet products


 
 EditMesh operations Macroscript file.
--***********************************************************************************************
-- MODIFY THIS AT YOUR OWN RISK
--
-- Renamed flt_EditM --> Filters.Is_EditMesh
*/


MacroScript EMesh_Attach
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		if subobjectlevel == undefined then max modify mode
		ApplyOperation Edit_Mesh meshops.startAttach
	
	)

)
MacroScript EMesh_Detach
enabledIn:#("max", "viz", "vizr") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try(ApplyOperation Edit_Mesh meshops.Detach)Catch(MessageBox "ʧ" Title:"༭")
		
	)

)
MacroScript EMesh_Weld
enabledIn:#("max", "viz", "vizr") --pfb: 2003.12.11 added product switch
ButtonText:"ѡ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"Ӷ()" 
-- Needs Icon
(
	On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		if subobjectlevel == undefined then max modify mode
		if subobjectlevel != 1 then subobjectlevel = 1
		
		ApplyOperation Edit_Mesh meshops.Weld
	
	)

)
MacroScript EMesh_Hide
enabledIn:#("max", "viz", "vizr") --pfb: 2003.12.11 added product switch
ButtonText:"()"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMeshSpecifyLevel #{2,4..6}

	On Execute Do
	(
		Try(ApplyOperation Edit_Mesh meshops.Hide)Catch(MessageBox "ʧ" Title:"༭")
	)

)
MacroScript EMesh_UnHide
enabledIn:#("max", "viz", "vizr") --pfb: 2003.12.11 added product switch
ButtonText:"ȫȡ()"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ȫȡ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMeshSpecifyLevel #{2,4..6}

	On Execute Do
	(
		Try(ApplyOperation Edit_Mesh meshops.UnHideAll)Catch(MessageBox "ʧ" Title:"༭")
	)
)
MacroScript EMesh_Collapse
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		Try(ApplyOperation Edit_Mesh meshops.collapse)Catch(MessageBox "ʧ" Title:"༭")
	)
)

MacroScript EMesh_View_Align
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"ͼ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ͼ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		if subobjectlevel == undefined then max modify mode
		if subobjectlevel == 0 then subobjectlevel = 4
		else ApplyOperation Edit_Mesh meshops.viewAlign
	)

)

MacroScript EMesh_Grid_Align
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"դ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"դ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(

		Try(ApplyOperation Edit_Mesh meshops.gridAlign)Catch(MessageBox "ʧ" Title:"༭")
	
	)

)
MacroScript EMesh_Make_Planer
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"ƽ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ƽ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		if subobjectlevel == undefined then max modify mode
		if subobjectlevel == 0 then subobjectlevel = 4
		else Try(ApplyOperation Edit_Mesh meshops.MakePlanar)Catch(MessageBox "ʧ" Title:"༭")
	
	)

)
MacroScript EMesh_Flip
enabledIn:#("max", "viz", "vizr") --pfb: 2003.12.11 added product switch
ButtonText:"תģʽ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"תѡ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		if subobjectlevel == undefined then max modify mode
		if subobjectlevel != 4 then subobjectlevel = 4
		Try(ApplyOperation Edit_Mesh meshops.startFlipNormalmode)Catch(MessageBox "ʧ" Title:"༭")
	
	)

)
MacroScript EMesh_Unify
enabledIn:#("max", "viz", "vizr") --pfb: 2003.12.11 added product switch
ButtonText:"ͳһ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ͳһ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(

		Try(ApplyOperation Edit_Mesh meshops.Unifynormal)Catch(MessageBox "ʧ" Title:"༭")
	
	)

)

MacroScript EMesh_Inset
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ѡ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(

		Try
		(
			extrudeface $ #selection 0 50
		)Catch(MessageBox "ʧ" Title:"༭")
	
	)

)
-- *******************************************************************
--  Mesh Ops:  Vertex Mode  
--
--  SO LEVELS: 1 = vertex; 2 = edges; 3 = faces; 4 = polygons
--
-- *******************************************************************

MacroScript EMesh_VChamfer
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"нǶ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"нǶ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		Try
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 1
			ApplyOperation Edit_Mesh meshops.startchamfer
		)
		Catch(MessageBox "ʧ" Title:"༭")
	
	)

)
MacroScript EMesh_VCreate
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 1
			ApplyOperation Edit_Mesh meshops.startCreate
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_VBreak
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"Ͽ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"Ͽ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			
			if SubObjectLevel == 1 then ApplyOperation Edit_Mesh meshops.break
			else SubObjectLevel = 1
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_RemoveIsolatedVerts
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"ɾ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ɾ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 1
			ApplyOperation Edit_Mesh meshops.removeisolatedverts
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_SlicePlane
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"Ƭƽ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"Ƭƽ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 4
			ApplyOperation Edit_Mesh meshops.startsliceplane
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)
MacroScript EMesh_TargetWeld
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"Ŀ꺸"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"Ŀ꺸()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 1
			ApplyOperation Edit_Mesh meshops.startWeldTarget
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

-- *******************************************************************
-- Mesh Ops:  Edge Mode 
--
--  SO LEVELS: 1 = vertex; 2 = edges; 3 = faces; 4 = polygons
--
-- *******************************************************************

MacroScript EMesh_EExtrude
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 2
			ApplyOperation Edit_Mesh meshops.startExtrude
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_EChamfer
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"нǱ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"нǱ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 2
			ApplyOperation Edit_Mesh meshops.startChamfer
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_ECut
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"б"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"б()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 2
			ApplyOperation Edit_Mesh meshops.startCut
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)


MacroScript EMesh_EDivide
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"ֱ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ֱ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 2
			ApplyOperation Edit_Mesh meshops.startDivide
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_ETurn
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"ģʽ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 2
			ApplyOperation Edit_Mesh meshops.startTurn
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_EVisible
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"ɼ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ɼ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 2
			ApplyOperation Edit_Mesh meshops.VisibleEdge
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_EInVisible
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"ɼ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ɼ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 2
			ApplyOperation Edit_Mesh meshops.InVisibleEdge
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_OpenEdges
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"ѡ񿪷ű"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ѡ񿪷ű()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 2
			ApplyOperation Edit_Mesh meshops.SelectOpenEdges
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_ShapeFromEdges
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"ɱߴͼ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ɱߴͼ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			SubObjectLevel = 2
			ApplyOperation Edit_Mesh meshops.CreateShapeFromEdges
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

-- *******************************************************************
--  Mesh Ops: Face Mode  
--
--  SO LEVELS: 1 = vertex; 2 = edges; 3 = faces; 4 = polygons
--
-- *******************************************************************

MacroScript EMesh_FExtrude
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 3 then subobjectlevel = 3
			ApplyOperation Edit_Mesh meshops.startExtrude
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_FBevel
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 3 then subobjectlevel = 3
			ApplyOperation Edit_Mesh meshops.startBevel
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_FCreate
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 3 then subobjectlevel = 3
			ApplyOperation Edit_Mesh meshops.startCreate
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_FCut
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 3 then subobjectlevel = 3
			ApplyOperation Edit_Mesh meshops.startCut
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_FDivide
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 3 then subobjectlevel = 3
			ApplyOperation Edit_Mesh meshops.startDivide
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_FFlip
enabledIn:#("max", "viz", "vizr") --pfb: 2003.12.11 added product switch
ButtonText:"ת"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ת()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 3 then subobjectlevel = 3
			ApplyOperation Edit_Mesh meshops.startFlipNormalmode
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

-- *******************************************************************
-- Mesh Ops: Polygon Mode 
--
--  SO LEVELS: 1 = vertex; 2 = edges; 3 = faces; 4 = polygons
--
-- *******************************************************************

MacroScript EMesh_PExtrude
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 4 then subobjectlevel = 4
			ApplyOperation Edit_Mesh meshops.startExtrude
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_PCreate
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 4 then subobjectlevel = 4
			ApplyOperation Edit_Mesh meshops.startCreate
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_PExtrude
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:""
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 4 then subobjectlevel = 4
			ApplyOperation Edit_Mesh meshops.startExtrude
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_PCut
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"ж"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ж()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 4 then subobjectlevel = 4
			ApplyOperation Edit_Mesh meshops.startCut
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)


MacroScript EMesh_PDivide
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"ֶ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ֶ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 4 then subobjectlevel = 4
			ApplyOperation Edit_Mesh meshops.startDivide
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_PBevel
enabledIn:#("max", "viz") --pfb: 2003.12.11 added product switch
ButtonText:"Ƕ"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"Ƕ()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 4 then subobjectlevel = 4
			ApplyOperation Edit_Mesh meshops.startBevel
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)

MacroScript EMesh_PFlip
enabledIn:#("max", "viz", "vizr") --pfb: 2003.12.11 added product switch
ButtonText:"ת"
Category:"Editable Mesh Object" 
internalCategory:"Editable Mesh Object" 
Tooltip:"ת()" 
-- Needs Icon
(
	--On IsEnabled Return Filters.Is_EditMesh()
	On IsVisible Return Filters.Is_EditMesh()

	On Execute Do
	(
		
		Try	
		(
			If SubObjectLevel == undefined then Max Modify Mode
			if subobjectlevel != 4 then subobjectlevel = 4
			ApplyOperation Edit_Mesh meshops.startFlipNormalMode
		)
		Catch(MessageBox "ʧ" Title:"༭")
	)

)





